<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama perumahan" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'residential', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Perumahan
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="residentials" ref="residentialTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama Perumahan"
                width="300">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Alamat"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.address + ', ' + scope.row.administrative_region.join(', ') }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Catatan"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.note }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'residential', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'residential', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="residentialForm" :model="residentialForm" :rules="residentialRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua perumahan yang dimiliki pemilik." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama Perumahan" prop="name">
                    <el-input ref="name" name="name" v-model="residentialForm.name" placeholder="Nama perumahan" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>     
                <el-row :gutter="20">
                    <el-col :lg="16" :md="24" :xs="24">
                        <el-form-item label="Alamat" prop="address">
                            <el-input ref="address" name="address" v-model="residentialForm.address" placeholder="Alamat lengkap" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="8" :md="24" :xs="24">
                        <el-form-item label="Kode Pos" prop="region">
                            <el-select
                                ref="region"
                                name="region"
                                class="width-100"
                                clearable
                                filterable
                                remote
                                :remote-method="getRegions"
                                v-model="residentialForm.region"
                                value-key="id"
                                placeholder="Ketik kode pos"
                                no-data-text="No Data"
                                :loading="regionLoading"
                                @change="handleRegionChange">
                                <el-option
                                    v-for="item in regions"
                                    :key="item.id"
                                    :label="item.name+' ('+item.postal+')'"
                                    :value="item.id">     
                                    <span style="float: left">{{ item.name }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">{{ getAdministrative(item) }}</strong>                   
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>   
                <el-form-item label="Catatan" prop="note">
                    <el-input ref="note" name="note" v-model="residentialForm.note" placeholder="Catatan" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>   
                <el-row :gutter="20">                      
                    <el-col :lg="me.role.slug=='root' ? 12 : 24" :md="24" :sm="24">
                        <el-form-item label="Tombol Panik" prop="panics">
                            <el-select 
                                multiple
                                filterable
                                remote
                                reverse-keyword
                                v-model="residentialForm.panics" 
                                placeholder="Pilih tombol panic" 
                                class="width-100" 
                                ref="panics" 
                                name="panics"
                                :remote-method="getPanics">
                                <el-option
                                    v-for="item in panics"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">                                 
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="12" :md="24" :sm="24" v-if="me.role.slug == 'root'">
                        <el-form-item label="Pilih Akun Pemilik" prop="owner">
                            <el-select                                 
                                v-model="residentialForm.owner" 
                                placeholder="Pilih akun pemilik" 
                                class="width-100" 
                                ref="owner" 
                                name="owner"
                                value-key="id">
                                <el-option
                                    v-for="item in users"
                                    :key="item.id"
                                    :label="item.profile.fullname"
                                    :value="item.id"> 
                                    <span style="float: left">{{ item.profile.fullname }}</span>
                                    <strong style="float: right; color: #8492a6; font-size: 13px">Pemilik</strong>                                
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>        
                <el-form-item label="" prop="restricted">
                    <el-checkbox v-model="residentialForm.restricted" @change="handleRestricted($event)">Batasi wilayah perumahan</el-checkbox>
                    <el-link v-if="residentialForm.polygon != null" @click="handleClearPolygon" icon="el-icon-close" type="danger"> Hapus Batas Wilayah</el-link>
                </el-form-item>
                <GmapMap 
                    id="map"
                    v-if="residentialForm.restricted == true" 
                    ref="mapRef"
                    :options="{
                        zoomControl: true,
                        mapTypeControl: false,
                        scaleControl: false,
                        streetViewControl: false,
                        rotateControl: false,
                        fullscreenControl: true,
                        disableDefaultUi: false
                    }"
                    :zoom="map.zoom"
                    :center="map.center">
                </GmapMap>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'residential', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import {gmapApi} from 'vue2-google-maps';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';
import { setTimeout } from 'timers';

export default {
    name: 'Residential',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateRestricted = (rule, value, callback) => {
            if(this.residentialForm.restricted == true && this.residentialForm.polygon == null){
                return callback(new Error('Silahkan tentukan batas wilayah perumahan'));
            }
            callback();
        };

        var validateOwner = (rule, value, callback) => {
            if(this.me.role.slug == 'root' && this.residentialForm.owner == null){
                return callback(new Error('Silahkan pilih akun pemilik'));
            }
            callback();
        };

        return {
            tableLoading: false,
            dialogLoading: false,
            regionLoading: false,
            panicLoading: false,
            filter: {
                keyword: ''
            },
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Perumahan',
                create: 'Tambah Perumahan'
            },
            map: {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                },
                polygonComplete: false,
                drawingManager: null,
                overlays: []
            },
            selectedRegion: null,
            residentialForm: {
                id: null,
                name: '',
                address: '',
                path: '',
                polygon: null,
                restricted: false,
                note: '',
                panics: [],
                region: null,
                archived: false,
                owner: null
            },
            residentialRules: {
                name: [{ 
                    required: true, message: 'Nama perumahan wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang Nama perumahan maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                address: [{
                    required: true, message: 'Alamat wajib diisi', trigger: 'blur'
                }, { 
                    max: 255, message: 'Panjang catatan maksimal 255 karakter', trigger: 'blur'
                }],
                region: [{
                    required: true, message: 'Kode pos wajib diisi', trigger: 'change',
                }],
                note: [{ max: 255, message: 'Panjang catatan maksimal 255 karakter', trigger: 'blur'}],
                restricted: [{
                    validator: validateRestricted, trigger: 'change'
                }],
                owner: [{
                    validator: validateOwner, trigger: 'change'
                }]
            },
        };
    },
    computed: {
        tableHeight,
        google: gmapApi,
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('region', ['regions']),
        ...mapGetters('panic', ['panics']),
        ...mapGetters('residential', [
            'residentials',
            'pagination'
        ]),
        
    },
    created() {
        this.getResidentials();
        this.getPanics();
        this.getOwners();
    },
    methods: {
        playSound,
        dateFormat,
        isNumeric(n) {
            return !isNaN(parseFloat(n)) && isFinite(n);
        },
        getAdministrative(region, level){
            var temp = [];
            level = level || 0;

            if(region.parents){
                temp.push(region.name);
                level++;
                temp.push.apply(temp, this.getAdministrative(region.parents, level));
            }else{
                temp.push(region.name);
            }

            if(temp.length == 4){
                temp.splice(0,2);
                return temp.join(', ');
            }
            
            return temp;
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getRegions(q) {
            if(q.length >= 3 && this.isNumeric(q)){
                this.regionLoading = true;
                this.$store.dispatch('region/getRegions', {
                    q: q,
                    page: this.pagination.page,
                    perpage: this.pagination.perpage
                }).then(() => {
                    this.regionLoading = false;
                });
            }
        },
        getPanics() {
            this.panicLoading = true;
            this.$store.dispatch('panic/getPanics', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.panicLoading = false;
            });
        },
        getOwners() {
            this.panicLoading = true;
            this.$store.dispatch('user/getUsers', {
                role: 739535000,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.panicLoading = false;
            });
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['residentialForm'].clearValidate();
            });
        },
        handleEdit(residential){

            var self = this;

            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.residentialForm.id = residential.id;
            this.residentialForm.name = residential.name;
            this.residentialForm.address = residential.address;
            this.residentialForm.note = residential.note;
            this.residentialForm.path = residential.path;
            this.residentialForm.polygon = JSON.parse(residential.polygon);
            this.residentialForm.restricted = residential.restricted;
            this.residentialForm.region = residential.region.id;
            this.residentialForm.archived = residential.archived;
            this.selectedRegion = residential.region;
            this.residentialForm.owner = residential.owner.id;
            this.getRegions(residential.region.postal);

            this.residentialForm.panics = residential.panics.map((x) => x.id);
            
            setTimeout(function(){
                self.handleChangeMap();
            }, 100);

            this.$nextTick(() => {
                this.$refs['residentialForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.residentialForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'residential/addResidential';
                        payload = {
                            name: this.residentialForm.name,
                            address: this.residentialForm.address,
                            note: this.residentialForm.note,
                            path: this.residentialForm.path,
                            polygon: JSON.stringify(this.residentialForm.polygon),
                            restricted: this.residentialForm.restricted,
                            region: this.residentialForm.region,
                            panics: this.residentialForm.panics,
                            owner: this.residentialForm.owner,
                            archived: this.residentialForm.archived
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'residential/editResidential';
                        payload = {
                            id: this.residentialForm.id,
                            name: this.residentialForm.name,
                            address: this.residentialForm.address,
                            note: this.residentialForm.note,
                            path: this.residentialForm.path,
                            polygon: JSON.stringify(this.residentialForm.polygon),
                            restricted: this.residentialForm.restricted,
                            region: this.residentialForm.region,
                            panics: this.residentialForm.panics,
                            owner: this.residentialForm.owner,
                            archived: this.residentialForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(residential){
            this.$confirm('Anda mencoba untuk menghapus data perumahan, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('residential/deleteResidential', {
                    id: residential.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.residentialForm = {
                id: null,
                name: '',
                address: '',
                path: '',
                polygon: null,
                restricted: false,
                note: '',
                region: null,
                archived: false,
                panics: [],
                owner: null
            }

            this.map ={
                zoom: 12,
                center: {
                    lat: -2.9549597,
                    lng: 104.6228777
                },
                polygonComplete: false,
                drawingManager: null,
                overlays: []
            }
        },
        handleRegionChange(value){            
            this.regions.filter((x) => {
                if(x.id == value){
                    this.selectedRegion = x;
                    this.map.center.lat = parseFloat(x.latitude);
                    this.map.center.lng = parseFloat(x.longitude);

                    this.handleClearPolygon();
                }
            }); 

            this.residentialForm.path = this.selectedRegion.path;            
            this.handleChangeMap();
        },
        handleRestricted(isRestricted){
            var self = this;
            this.residentialForm.restricted = isRestricted;
            if(isRestricted){
                setTimeout(function(){
                    self.handleChangeMap();
                }, 100);
            }else{
                this.map ={
                    zoom: 12,
                    center: {
                        lat: -2.9549597,
                        lng: 104.6228777
                    },
                    polygonComplete: false,
                    drawingManager: null,
                    overlays: []
                }
            }
            
        },
        handleChangeMap(){

            var self = this;

            if(self.residentialForm.restricted){

                self.$refs.mapRef.$mapPromise.then((map) => {

                    map.setZoom(15);

                    let panLatLng = self.map.center;

                    if(self.residentialForm.region != null){
                        panLatLng = {
                            lat: parseFloat(self.selectedRegion.latitude), 
                            lng: parseFloat(self.selectedRegion.longitude)
                        }
                    }

                    map.panTo(panLatLng);

                    var google = self.google;
                    var drawingManagerOptions = {
                        drawingMode: google.maps.drawing.OverlayType.POLYGON,
                        drawingControl: false,
                        drawingControlOptions: {
                            position: google.maps.ControlPosition.TOP_CENTER,
                            drawingModes: [google.maps.drawing.OverlayType.POLYGON]
                        },
                        polygonOptions: {
                            fillColor: '#C8B2F4',
                            fillOpacity: 0.4,
                            strokeColor: '#ED858A',
                            strokeWeight: 3,
                            clickable: true,
                            zIndex: 1,
                            editable: true,
                            draggable: false
                        }
                    };                    

                    self.map.drawingManager = new google.maps.drawing.DrawingManager(drawingManagerOptions);
                    self.map.drawingManager.setMap(map);

                    if(self.residentialForm.polygon != null){                        
                        var coverage = new google.maps.Polygon({
                            paths: self.residentialForm.polygon,
                            fillColor: '#C8B2F4',
                            fillOpacity: 0.4,
                            strokeColor: '#ED858A',
                            strokeWeight: 3,
                            clickable: true,
                            zIndex: 1,
                            editable: true,
                            draggable: false
                        });       

                        coverage.setMap(map);

                        self.map.overlays.push({
                            overlay: coverage,
                            type: google.maps.drawing.OverlayType.POLYGON
                        });

                        self.map.polygonComplete = true;
                        self.map.drawingManager.setMap(null);

                        var bounds = new google.maps.LatLngBounds();

                        coverage.getPath().forEach(function (path, index) {
                            bounds.extend(path);
                        });
                        
                        map.fitBounds(bounds);
                    }

                    google.maps.Polygon.prototype.enableCoordinatesChangedEvent = function () {

                        var me = this,
                            isBeingDragged = false,
                            triggerCoordinatesChanged = function () {
                                google.maps.event.trigger(me, 'coordinates_changed');
                            };

                        google.maps.event.addListener(me, 'dragstart', function () {
                            isBeingDragged = true;
                        });

                        google.maps.event.addListener(me, 'dragend', function () {
                            triggerCoordinatesChanged();
                            isBeingDragged = false;
                        });

                        var paths = me.getPaths();
                        paths.forEach(function (path) {
                            google.maps.event.addListener(path, "insert_at", function () {
                                triggerCoordinatesChanged();
                            });
                            google.maps.event.addListener(path, "set_at", function () {
                                if (!isBeingDragged) {
                                    triggerCoordinatesChanged();
                                }
                            });
                            google.maps.event.addListener(path, "remove_at", function () {
                                triggerCoordinatesChanged();
                            });
                        });
                    };

                    google.maps.event.addListener(self.map.drawingManager, 'overlaycomplete', function(e) {
                        self.map.overlays.push(e);

                        var vertices = e.overlay.getPath().getArray();

                        self.addPolygonPaths(vertices);

                        self.map.polygonComplete = true;
                        self.map.drawingManager.setMap(null);

                        e.overlay.enableCoordinatesChangedEvent();

                        google.maps.event.addListener(e.overlay, 'coordinates_changed', function () {
                            var vertices = e.overlay.getPath().getArray();
                            self.addPolygonPaths(vertices);
                        });

                    });

                });
            }
        },
        addPolygonPaths(vertices) {
            var coordinates = [];

            for(const x of vertices){
                coordinates.push({
                    lat: x.lat(),
                    lng: x.lng()
                });
            }

            this.residentialForm.polygon = coordinates;

        },
        handleClearPolygon(){
            this.residentialForm.polygon = null;           
            this.map.polygonComplete = false;
            
            for(const i of this.map.overlays){
                i.overlay.setMap(null);
            }

            this.map.overlays = [];

            this.handleChangeMap();
        }
    }

}
</script>
<style>
    #map{
        width: 100%;
        height: 400px;
    }
</style>
